	
#include "PacmanPink.h"

#include "core/CoreIncludes.h"
#include "BulletDynamics/Dynamics/btRigidBody.h"

	
namespace orxonox{

	RegisterClass(PacmanPink);

		PacmanPink::PacmanPink(Context* context) : PacmanGhost(context){

        RegisterObject(PacmanPink);

        this->target_x=0;
        this->target_z=15;
        this->lastPlayerPassedPoint=Vector3(0,0,0); //Vector3(70,10,-135);
        this->pointInFrontOfPlayer=Vector3(0,0,0);
          
    }

    /**
    @brief
        Method for creating a ghost through XML.
    */
    void PacmanPink::XMLPort(Element& xmlelement, XMLPort::Mode mode)
    {
        SUPER(PacmanPink, XMLPort, xmlelement, mode);
    }


    void PacmanPink::tick(float dt)
    {
        SUPER(PacmanGhost, tick, dt);

        this->actuelposition = this->getPosition();
        //std::cout<<this->actuelposition<<endl;


        for(int u=0; u < 67; u++){//always check if player passed a point
            if(jeanfindpos(this->getPlayerPos(), possibleposition[u])){ 
                    this->lastPlayerPassedPoint=possibleposition[u];        
                }
            }

        int directionV = findPlayerTravDir (lastPlayerPassedPoint, this->getPlayerPos());
        this->pointInFrontOfPlayer=frontPosition(); //getPointInFrontOfPacman(lastPlayerPassedPoint, directionV);
        //std::cout<<this->pointInFrontOfPlayer<<endl;
        //std::cout<<this->lastPlayerPassedPoint<<endl;

        Vector3 pinkPos=Vector3(this->target_x, 10, this->target_z);
        //std::cout<<pinkPos<<endl;
        
        //Stop, if target arrived
        if((abs(this->actuelposition.x - this->target_x)<0.5) && (abs(this->actuelposition.z - this->target_z)<0.5)){
                 this->ismoving = false;
        }

        //Move, if ghost hasn't arrived yet
        if(this->ismoving){
            if(!(abs(this->actuelposition.z-target_z)<0.5)) {
                velocity = Vector3(0,0,-sgn(this->actuelposition.z-this->target_z));
                move(dt, actuelposition, velocity);
            }    
            if(!(abs(this->actuelposition.x-target_x)<0.5)){
                velocity = Vector3(-sgn(this->actuelposition.x-this->target_x),0,0);
                move(dt, actuelposition, velocity);
            }
        }
        else if(this->lastPlayerPassedPoint==Vector3(0,0,0)){
            //as long as the player has not started the game,
            //i.e. lastPlayerPastPoint is (0,0,0), pink pacman
            //cannot possibly move, because it needs the position
            //of the player to move accordingly

            this->ismoving=false;
        }
        else if(this->pointInFrontOfPlayer==Vector3(0,0,0)){
            std::cout<<"arheeuuuu"<<endl;

            Vector3 pinkPos=Vector3(this->target_x, 10, this->target_z);

            setNewTargetGhost(getShortestPath(pinkPos, this->lastPlayerPassedPoint));


        }
        //Check on which position the ghost has arrived and set new target
         else{
            while(lockmove){};
            lockmove = true;

            //Vector3 pinkPos=Vector3(this->target_x, 10, this->target_z);
            //std::cout<<pinkPos<<endl;

            //int directionV = findPlayerTravDir (lastPlayerPassedPoint, this->getPlayerPos());
            //this->pointInFrontOfPlayer=getPointInFrontOfPacman(lastPlayerPassedPoint, directionV);
            
            //std::cout<<this->lastPlayerPassedPoint<<endl;

            //std::cout<<this->pointInFrontOfPlayer<<endl;
            nextMove(pinkPos, pointInFrontOfPlayer, lastPlayerPassedPoint);


            lockmove=false;

        }





	}



    void PacmanPink::nextMove( Vector3 pinkPosP, Vector3 playerPos, Vector3 pointToAvoidP11){
    
        Vector3 nextTarget;

        std::cout<<this->actuelposition<<endl;
        std::cout<<pinkPosP<<endl;
        std::cout<<playerPos<<endl;
        std::cout<<pointToAvoidP11<<endl;
        std::cout<<this->getPlayerPos()<<endl;

        if(playerPos==pointToAvoidP11){ //SIGSEV if playerPos==pointToAvoidP11 otherwise
            nextTarget = getShortestPath(pinkPosP, playerPos);
        }
        /*else if(pinkPosP==pointToAvoidP11){
            nextTarget=getShortestPath(pinkPosP, playerPos);
        }*/
        else{
            //bugs here
            std::cout<<"msjiowjqiq"<<endl;
        nextTarget = getShortestPath(pinkPosP, playerPos, pointToAvoidP11);
        }
    
       setNewTargetGhost(nextTarget);
    }

}

	

	
